#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_EXT_EXTENDED_DYNAMIC_STATE_2_SPEC_VERSION")]
pub const EXT_EXTENDED_DYNAMIC_STATE_2_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_EXT_EXTENDED_DYNAMIC_STATE_2_EXTENSION_NAME")]
pub const EXT_EXTENDED_DYNAMIC_STATE_2_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_EXT_extended_dynamic_state2");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_SET_PATCH_CONTROL_POINTS_EXT: *const std::os::raw::c_char = crate::cstr!("vkCmdSetPatchControlPointsEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_SET_RASTERIZER_DISCARD_ENABLE_EXT: *const std::os::raw::c_char = crate::cstr!("vkCmdSetRasterizerDiscardEnableEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_SET_DEPTH_BIAS_ENABLE_EXT: *const std::os::raw::c_char = crate::cstr!("vkCmdSetDepthBiasEnableEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_SET_LOGIC_OP_EXT: *const std::os::raw::c_char = crate::cstr!("vkCmdSetLogicOpEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CMD_SET_PRIMITIVE_RESTART_ENABLE_EXT: *const std::os::raw::c_char = crate::cstr!("vkCmdSetPrimitiveRestartEnableEXT");
#[doc = "Provided by [`crate::extensions::ext_extended_dynamic_state2`]"]
impl crate::vk1_0::DynamicState {
    pub const PATCH_CONTROL_POINTS_EXT: Self = Self(1000377000);
    pub const RASTERIZER_DISCARD_ENABLE_EXT: Self = Self(1000377001);
    pub const DEPTH_BIAS_ENABLE_EXT: Self = Self(1000377002);
    pub const LOGIC_OP_EXT: Self = Self(1000377003);
    pub const PRIMITIVE_RESTART_ENABLE_EXT: Self = Self(1000377004);
}
#[doc = "Provided by [`crate::extensions::ext_extended_dynamic_state2`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_EXTENDED_DYNAMIC_STATE_2_FEATURES_EXT: Self = Self(1000377000);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetPatchControlPointsEXT.html)) · Function <br/> vkCmdSetPatchControlPointsEXT - Specify the number of control points per patch\n[](#_c_specification)C Specification\n----------\n\nTo dynamically specify the number of control points per patch:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetPatchControlPointsEXT(\n    VkCommandBuffer                             commandBuffer,\n    uint32_t                                    patchControlPoints);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::patch_control_points`] specifies number of control points per patch.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::PATCH_CONTROL_POINTS_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-None-04873  \n   The [extendedDynamicState2PatchControlPoints](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2PatchControlPoints) feature **must** be enabled\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-patchControlPoints-04874  \n  [`Self::patch_control_points`] **must** be greater than zero and less than or\n  equal to [`crate::vk::PhysicalDeviceLimits`]::`maxTessellationPatchSize`\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdSetPatchControlPointsEXT = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, patch_control_points: u32) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetRasterizerDiscardEnableEXT.html)) · Function <br/> vkCmdSetRasterizerDiscardEnableEXT - Control whether primitives are discarded before the rasterization stage for a command buffer\n[](#_c_specification)C Specification\n----------\n\nTo dynamically control whether primitives are discarded before the\nrasterization stage:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetRasterizerDiscardEnableEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkBool32                                    rasterizerDiscardEnable);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::rasterizer_discard_enable`] controls whether primitives are discarded\n  immediately before the rasterization stage.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::RASTERIZER_DISCARD_ENABLE_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-None-04871  \n   The [extendedDynamicState2](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2) feature**must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::CommandBuffer`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdSetRasterizerDiscardEnableEXT = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, rasterizer_discard_enable: crate::vk1_0::Bool32) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetDepthBiasEnableEXT.html)) · Function <br/> vkCmdSetDepthBiasEnableEXT - Controls whether to bias fragment depth values for a command buffer\n[](#_c_specification)C Specification\n----------\n\nTo dynamically control whether to bias fragment depth values:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetDepthBiasEnableEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkBool32                                    depthBiasEnable);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::depth_bias_enable`] controls whether to bias fragment depth values.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::DEPTH_BIAS_ENABLE_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-None-04872  \n   The [extendedDynamicState2](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2) feature**must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::CommandBuffer`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdSetDepthBiasEnableEXT = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, depth_bias_enable: crate::vk1_0::Bool32) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetLogicOpEXT.html)) · Function <br/> vkCmdSetLogicOpEXT - Select which logical operation to apply for blend state\n[](#_c_specification)C Specification\n----------\n\nTo dynamically set the logical operation to apply for blend state:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetLogicOpEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkLogicOp                                   logicOp);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::logic_op`] specifies the logical operation to apply for blend state.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::LOGIC_OP_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetLogicOpEXT-None-04867  \n   The [extendedDynamicState2LogicOp](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2LogicOp) feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetLogicOpEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetLogicOpEXT-logicOp-parameter  \n  [`Self::logic_op`] **must** be a valid [`crate::vk::LogicOp`] value\n\n* []() VUID-vkCmdSetLogicOpEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetLogicOpEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`], [`crate::vk::LogicOp`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdSetLogicOpEXT = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, logic_op: crate::vk1_0::LogicOp) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetPrimitiveRestartEnableEXT.html)) · Function <br/> vkCmdSetPrimitiveRestartEnableEXT - Control whether a special vertex index value is treated as restarting the assembly of primitives\n[](#_c_specification)C Specification\n----------\n\nTo dynamically control whether a special vertex index value is treated as\nrestarting the assembly of primitives:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetPrimitiveRestartEnableEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkBool32                                    primitiveRestartEnable);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::primitive_restart_enable`] controls whether a special vertex index\n  value is treated as restarting the assembly of primitives.\n  It behaves in the same way as[`crate::vk::PipelineInputAssemblyStateCreateInfo`]::[`Self::primitive_restart_enable`]\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::PRIMITIVE_RESTART_ENABLE_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-None-04866  \n   The [extendedDynamicState2](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2) feature**must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::CommandBuffer`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCmdSetPrimitiveRestartEnableEXT = unsafe extern "system" fn(command_buffer: crate::vk1_0::CommandBuffer, primitive_restart_enable: crate::vk1_0::Bool32) -> ();
impl<'a> crate::ExtendableFromConst<'a, PhysicalDeviceExtendedDynamicState2FeaturesEXT> for crate::vk1_0::DeviceCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromConst<'a, PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'_>> for crate::vk1_0::DeviceCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDeviceExtendedDynamicState2FeaturesEXT> for crate::vk1_1::PhysicalDeviceFeatures2Builder<'a> {}
impl<'a> crate::ExtendableFromMut<'a, PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'_>> for crate::vk1_1::PhysicalDeviceFeatures2Builder<'a> {}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExtendedDynamicState2FeaturesEXT.html)) · Structure <br/> VkPhysicalDeviceExtendedDynamicState2FeaturesEXT - Structure describing what extended dynamic state can be used\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExtendedDynamicState2FeaturesEXT`] structure is\ndefined as:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\ntypedef struct VkPhysicalDeviceExtendedDynamicState2FeaturesEXT {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           extendedDynamicState2;\n    VkBool32           extendedDynamicState2LogicOp;\n    VkBool32           extendedDynamicState2PatchControlPoints;\n} VkPhysicalDeviceExtendedDynamicState2FeaturesEXT;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following features:\n[](#_description)Description\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() [`Self::extended_dynamic_state2`] indicates\n  that the implementation supports the following dynamic states:\n\n  * [`crate::vk::DynamicState::DEPTH_BIAS_ENABLE_EXT`]\n\n  * [`crate::vk::DynamicState::PRIMITIVE_RESTART_ENABLE_EXT`]\n\n  * [`crate::vk::DynamicState::RASTERIZER_DISCARD_ENABLE_EXT`]\n\n* []()[`Self::extended_dynamic_state2_logic_op`] indicates that the implementation\n  supports the following dynamic state:\n\n  * [`crate::vk::DynamicState::LOGIC_OP_EXT`]\n\n* []()[`Self::extended_dynamic_state2_patch_control_points`] indicates that the\n  implementation supports the following dynamic state:\n\n  * [`crate::vk::DynamicState::PATCH_CONTROL_POINTS_EXT`]\n\nIf the [`crate::vk::PhysicalDeviceExtendedDynamicState2FeaturesEXT`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceExtendedDynamicState2FeaturesEXT`] **can** also be used in the [`Self::p_next`] chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExtendedDynamicState2FeaturesEXT-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTENDED_DYNAMIC_STATE_2_FEATURES_EXT`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceExtendedDynamicState2FeaturesEXT")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct PhysicalDeviceExtendedDynamicState2FeaturesEXT {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *mut std::ffi::c_void,
    pub extended_dynamic_state2: crate::vk1_0::Bool32,
    pub extended_dynamic_state2_logic_op: crate::vk1_0::Bool32,
    pub extended_dynamic_state2_patch_control_points: crate::vk1_0::Bool32,
}
impl PhysicalDeviceExtendedDynamicState2FeaturesEXT {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::PHYSICAL_DEVICE_EXTENDED_DYNAMIC_STATE_2_FEATURES_EXT;
}
impl Default for PhysicalDeviceExtendedDynamicState2FeaturesEXT {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null_mut(), extended_dynamic_state2: Default::default(), extended_dynamic_state2_logic_op: Default::default(), extended_dynamic_state2_patch_control_points: Default::default() }
    }
}
impl std::fmt::Debug for PhysicalDeviceExtendedDynamicState2FeaturesEXT {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("PhysicalDeviceExtendedDynamicState2FeaturesEXT").field("s_type", &self.s_type).field("p_next", &self.p_next).field("extended_dynamic_state2", &(self.extended_dynamic_state2 != 0)).field("extended_dynamic_state2_logic_op", &(self.extended_dynamic_state2_logic_op != 0)).field("extended_dynamic_state2_patch_control_points", &(self.extended_dynamic_state2_patch_control_points != 0)).finish()
    }
}
impl PhysicalDeviceExtendedDynamicState2FeaturesEXT {
    #[inline]
    pub fn into_builder<'a>(self) -> PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
        PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceExtendedDynamicState2FeaturesEXT.html)) · Builder of [`PhysicalDeviceExtendedDynamicState2FeaturesEXT`] <br/> VkPhysicalDeviceExtendedDynamicState2FeaturesEXT - Structure describing what extended dynamic state can be used\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceExtendedDynamicState2FeaturesEXT`] structure is\ndefined as:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\ntypedef struct VkPhysicalDeviceExtendedDynamicState2FeaturesEXT {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           extendedDynamicState2;\n    VkBool32           extendedDynamicState2LogicOp;\n    VkBool32           extendedDynamicState2PatchControlPoints;\n} VkPhysicalDeviceExtendedDynamicState2FeaturesEXT;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following features:\n[](#_description)Description\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() [`Self::extended_dynamic_state2`] indicates\n  that the implementation supports the following dynamic states:\n\n  * [`crate::vk::DynamicState::DEPTH_BIAS_ENABLE_EXT`]\n\n  * [`crate::vk::DynamicState::PRIMITIVE_RESTART_ENABLE_EXT`]\n\n  * [`crate::vk::DynamicState::RASTERIZER_DISCARD_ENABLE_EXT`]\n\n* []()[`Self::extended_dynamic_state2_logic_op`] indicates that the implementation\n  supports the following dynamic state:\n\n  * [`crate::vk::DynamicState::LOGIC_OP_EXT`]\n\n* []()[`Self::extended_dynamic_state2_patch_control_points`] indicates that the\n  implementation supports the following dynamic state:\n\n  * [`crate::vk::DynamicState::PATCH_CONTROL_POINTS_EXT`]\n\nIf the [`crate::vk::PhysicalDeviceExtendedDynamicState2FeaturesEXT`] structure is included in the [`Self::p_next`] chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceExtendedDynamicState2FeaturesEXT`] **can** also be used in the [`Self::p_next`] chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceExtendedDynamicState2FeaturesEXT-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_EXTENDED_DYNAMIC_STATE_2_FEATURES_EXT`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[repr(transparent)]
pub struct PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a>(PhysicalDeviceExtendedDynamicState2FeaturesEXT, std::marker::PhantomData<&'a ()>);
impl<'a> PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
    #[inline]
    pub fn new() -> PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
        PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn extended_dynamic_state2(mut self, extended_dynamic_state2: bool) -> Self {
        self.0.extended_dynamic_state2 = extended_dynamic_state2 as _;
        self
    }
    #[inline]
    pub fn extended_dynamic_state2_logic_op(mut self, extended_dynamic_state2_logic_op: bool) -> Self {
        self.0.extended_dynamic_state2_logic_op = extended_dynamic_state2_logic_op as _;
        self
    }
    #[inline]
    pub fn extended_dynamic_state2_patch_control_points(mut self, extended_dynamic_state2_patch_control_points: bool) -> Self {
        self.0.extended_dynamic_state2_patch_control_points = extended_dynamic_state2_patch_control_points as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> PhysicalDeviceExtendedDynamicState2FeaturesEXT {
        self.0
    }
}
impl<'a> std::default::Default for PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
    fn default() -> PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
    type Target = PhysicalDeviceExtendedDynamicState2FeaturesEXT;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for PhysicalDeviceExtendedDynamicState2FeaturesEXTBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "Provided by [`crate::extensions::ext_extended_dynamic_state2`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetPatchControlPointsEXT.html)) · Function <br/> vkCmdSetPatchControlPointsEXT - Specify the number of control points per patch\n[](#_c_specification)C Specification\n----------\n\nTo dynamically specify the number of control points per patch:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetPatchControlPointsEXT(\n    VkCommandBuffer                             commandBuffer,\n    uint32_t                                    patchControlPoints);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::patch_control_points`] specifies number of control points per patch.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::PATCH_CONTROL_POINTS_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-None-04873  \n   The [extendedDynamicState2PatchControlPoints](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2PatchControlPoints) feature **must** be enabled\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-patchControlPoints-04874  \n  [`Self::patch_control_points`] **must** be greater than zero and less than or\n  equal to [`crate::vk::PhysicalDeviceLimits`]::`maxTessellationPatchSize`\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetPatchControlPointsEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`]\n"]
    #[doc(alias = "vkCmdSetPatchControlPointsEXT")]
    pub unsafe fn cmd_set_patch_control_points_ext(&self, command_buffer: crate::vk1_0::CommandBuffer, patch_control_points: u32) -> () {
        let _function = self.cmd_set_patch_control_points_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _, patch_control_points as _);
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetRasterizerDiscardEnableEXT.html)) · Function <br/> vkCmdSetRasterizerDiscardEnableEXT - Control whether primitives are discarded before the rasterization stage for a command buffer\n[](#_c_specification)C Specification\n----------\n\nTo dynamically control whether primitives are discarded before the\nrasterization stage:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetRasterizerDiscardEnableEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkBool32                                    rasterizerDiscardEnable);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::rasterizer_discard_enable`] controls whether primitives are discarded\n  immediately before the rasterization stage.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::RASTERIZER_DISCARD_ENABLE_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-None-04871  \n   The [extendedDynamicState2](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2) feature**must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetRasterizerDiscardEnableEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::CommandBuffer`]\n"]
    #[doc(alias = "vkCmdSetRasterizerDiscardEnableEXT")]
    pub unsafe fn cmd_set_rasterizer_discard_enable_ext(&self, command_buffer: crate::vk1_0::CommandBuffer, rasterizer_discard_enable: bool) -> () {
        let _function = self.cmd_set_rasterizer_discard_enable_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _, rasterizer_discard_enable as _);
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetDepthBiasEnableEXT.html)) · Function <br/> vkCmdSetDepthBiasEnableEXT - Controls whether to bias fragment depth values for a command buffer\n[](#_c_specification)C Specification\n----------\n\nTo dynamically control whether to bias fragment depth values:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetDepthBiasEnableEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkBool32                                    depthBiasEnable);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::depth_bias_enable`] controls whether to bias fragment depth values.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::DEPTH_BIAS_ENABLE_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-None-04872  \n   The [extendedDynamicState2](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2) feature**must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetDepthBiasEnableEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::CommandBuffer`]\n"]
    #[doc(alias = "vkCmdSetDepthBiasEnableEXT")]
    pub unsafe fn cmd_set_depth_bias_enable_ext(&self, command_buffer: crate::vk1_0::CommandBuffer, depth_bias_enable: bool) -> () {
        let _function = self.cmd_set_depth_bias_enable_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _, depth_bias_enable as _);
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetLogicOpEXT.html)) · Function <br/> vkCmdSetLogicOpEXT - Select which logical operation to apply for blend state\n[](#_c_specification)C Specification\n----------\n\nTo dynamically set the logical operation to apply for blend state:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetLogicOpEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkLogicOp                                   logicOp);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::logic_op`] specifies the logical operation to apply for blend state.\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::LOGIC_OP_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetLogicOpEXT-None-04867  \n   The [extendedDynamicState2LogicOp](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2LogicOp) feature **must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetLogicOpEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetLogicOpEXT-logicOp-parameter  \n  [`Self::logic_op`] **must** be a valid [`crate::vk::LogicOp`] value\n\n* []() VUID-vkCmdSetLogicOpEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetLogicOpEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::CommandBuffer`], [`crate::vk::LogicOp`]\n"]
    #[doc(alias = "vkCmdSetLogicOpEXT")]
    pub unsafe fn cmd_set_logic_op_ext(&self, command_buffer: crate::vk1_0::CommandBuffer, logic_op: crate::vk1_0::LogicOp) -> () {
        let _function = self.cmd_set_logic_op_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _, logic_op as _);
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCmdSetPrimitiveRestartEnableEXT.html)) · Function <br/> vkCmdSetPrimitiveRestartEnableEXT - Control whether a special vertex index value is treated as restarting the assembly of primitives\n[](#_c_specification)C Specification\n----------\n\nTo dynamically control whether a special vertex index value is treated as\nrestarting the assembly of primitives:\n\n```\n// Provided by VK_EXT_extended_dynamic_state2\nvoid vkCmdSetPrimitiveRestartEnableEXT(\n    VkCommandBuffer                             commandBuffer,\n    VkBool32                                    primitiveRestartEnable);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::command_buffer`] is the command buffer into which the command will be\n  recorded.\n\n* [`Self::primitive_restart_enable`] controls whether a special vertex index\n  value is treated as restarting the assembly of primitives.\n  It behaves in the same way as[`crate::vk::PipelineInputAssemblyStateCreateInfo`]::[`Self::primitive_restart_enable`]\n[](#_description)Description\n----------\n\nThis command sets the state for a given draw when the graphics pipeline is\ncreated with [`crate::vk::DynamicState::PRIMITIVE_RESTART_ENABLE_EXT`] set in[`crate::vk::PipelineDynamicStateCreateInfo::p_dynamic_states`].\n\nValid Usage\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-None-04866  \n   The [extendedDynamicState2](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-extendedDynamicState2) feature**must** be enabled\n\nValid Usage (Implicit)\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-commandBuffer-parameter  \n  [`Self::command_buffer`] **must** be a valid [`crate::vk::CommandBuffer`] handle\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-commandBuffer-recording  \n  [`Self::command_buffer`] **must** be in the [recording state](#commandbuffers-lifecycle)\n\n* []() VUID-vkCmdSetPrimitiveRestartEnableEXT-commandBuffer-cmdpool  \n   The [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** support graphics operations\n\nHost Synchronization\n\n* Host access to [`Self::command_buffer`] **must** be externally synchronized\n\n* Host access to the [`crate::vk::CommandPool`] that [`Self::command_buffer`] was allocated from **must** be externally synchronized\n\nCommand Properties\n\n|[Command Buffer Levels](#VkCommandBufferLevel)|[Render Pass Scope](#vkCmdBeginRenderPass)|[Supported Queue Types](#VkQueueFlagBits)|\n|----------------------------------------------|------------------------------------------|-----------------------------------------|\n|           Primary  <br/>Secondary            |                   Both                   |                Graphics                 |\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::CommandBuffer`]\n"]
    #[doc(alias = "vkCmdSetPrimitiveRestartEnableEXT")]
    pub unsafe fn cmd_set_primitive_restart_enable_ext(&self, command_buffer: crate::vk1_0::CommandBuffer, primitive_restart_enable: bool) -> () {
        let _function = self.cmd_set_primitive_restart_enable_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(command_buffer as _, primitive_restart_enable as _);
        ()
    }
}
